﻿using Console.Waterworks.Core.CoOrdinators;

namespace Console.Waterworks.Core
{
    public class CW_Liaison
    {
        CoOrdinator _kevin = new CoOrdinator();

        /// <summary>
        /// Hands control over to Console.Waterworks.Core so the program can "run" as intended.
        /// </summary>
        /// <param name="consoleCommandsNamespace">The place where the program's command-methods are.</param>
        /// <param name="includeProgramInfo">Information about the console program, stated in Assembly Information.</param>
        public void Run(string consoleCommandsNamespace,bool includeProgramInfo)
        {
            _kevin.PrepareConsoleEnvironment();
            if (includeProgramInfo == true) _kevin.DisplayProgramInfo();
            _kevin.RunProgram(consoleCommandsNamespace);
        }

        /// <summary>
        /// Displays all the attribute information it can find, attached to the command-methods, at run-time.
        /// </summary>
        /// <remarks>
        /// The returned string does not include the "help" information.
        /// It returns a string to indicate the method has finished collating the attribute information and displaying the information in the console.
        /// This method is intended to be use in a command-method. So, it aims to be compatible with command-method behaviour
        /// </remarks>
        /// <param name="consoleCommandsNamespace">The location of the programs command-method.</param>
        public string RequestHelpDocumentation(string consoleCommandsNamespace) => _kevin.DisplayHelpSection(consoleCommandsNamespace);
    }
}
