# Summary

Console.Waterworks.Core is the .Net **Core** version of Console.Waterworks. Both projects are NuGet packages and their main purpose is to help you write extendable command-based console programs. If you want to write a console program using the full .Net Framework, use Console.Waterworks. The link for that is as follows:

- [Console.Waterworks Repository](https://git.abbether.net/craig.oates/Console.Waterworks)

## Pre-Requisites

To use Console.Waterworks.Core, I recommend you meet the following pre-requisites:

- You have experience with [C#](https://docs.microsoft.com/en-us/dotnet/csharp/).
- You can create a [.Net console program](https://docs.microsoft.com/en-us/dotnet/core/tutorials/with-visual-studio) in [Visual Studio 2017+](https://www.visualstudio.com/vs/).
- You have experience with [NuGet](https://www.nuget.org/).
- You have experience with [.Net Core 2.1](https://dotnet.microsoft.com/download/dotnet-core/2.1).

## Console.Waterworks.Core (Library/NuGet Package)

This is a .Net Core 2.0 library and I wrote it in C#. This is what you will add to your project when you want to add the features of this codebase into yours. To add it to your project, use the following command in your Package-Manager console (assuming Visual Studio),

```powershell
// Make sure you change the version number to match the one you want.
Install-Package Console.Waterworks.Core -Version 1.0.0.1
```

If you are using the .Net CLI, use the following command,

```powershell
// Again, make sure you change the version number to the one you want.
dotnet add package Console.Waterworks.Core --version 1.0.0.1
```

For more information, please use the following links:

- [Console.Waterworks.Core Wiki](https://git.abbether.net/craig.oates/Console.Waterworks.Core/wiki)
- [NuGet Profile Page](https://www.nuget.org/packages/Console.Waterworks.Core/)

## CW_Core_Console

This is a .Net Core console program which provides a working example of how Console.Waterworks.Core works. You can use this as a reference to help you familiarise yourself with how to add/use Console.Waterworks to/with your project. This is written in C#.

## CW_Core_Tests

This is a .Net Core library which houses the solution's unit tests. This is written in C# and uses xUnit as its testing framework/library/situation/whatever-you-want-to-call-it.

## About the Creator

Hi, my name is Craig and I'm the creator of Console.Waterworks.Core. Thanks for checking it out.

- Email: [craig@craigoates.net](mailto:craig@craigoates.net)
- Web: [craigoates.net](http://www.craigoates.net)
- Project's Site: [craigoates.net/software/project/8](www.craigoates.net/Software/project/8) 

## A Note about Console.Waterworks.Core Wiki

This repository's wiki focuses on how-to **use** Console.Waterworks.Core. This is because the architecture and concepts between this and its sister project (Console.Waterworks) are the same. And, it felt unnecessary to repeat what I wrote in the wiki for Console.Waterworks here. So, if you want information on how Console.Waterworks(.Core) is built, I recommend you glance over the wiki here and then head over to the main wiki at Console.Waterworks. The link for both is as follows:

- [Console.Waterworks.Core Wiki](https://git.abbether.net/craig.oates/Console.Waterworks.Core/wiki)
- [Console.Waterworks Wiki](https://git.abbether.net/craig.oates/Console.Waterworks/wiki)